use diesel::{ExpressionMethods, Insertable, PgConnection, QueryDsl, Queryable, RunQueryDsl};
use serde::{Serialize, Deserialize};
use uuid::Uuid;
use crate::schema::schema::gamenight_participants;

use super::error::DatabaseError;

#[derive(Serialize, Deserialize, Debug, Insertable, Queryable)]
#[diesel(belongs_to(Gamenight))]
#[diesel(belongs_to(User))]
#[diesel(table_name = gamenight_participants)]
pub struct GamenightParticipants {
    pub gamenight_id: Uuid,
    pub user_id: Uuid,
}

pub fn gamenight_participants(conn: &mut PgConnection, id: Uuid) -> Result<Vec<GamenightParticipants>, DatabaseError> {
    Ok(gamenight_participants::table
        .filter(gamenight_participants::gamenight_id.eq(id))
        .get_results(conn)?)
}