use std::fmt::Display;

use chrono::{DateTime, Local};
use gamenight_api_client_rs::models;

#[derive(Clone)]
pub struct Gamenight {
    pub name: String,
    pub start_time: DateTime<Local>
}

impl From<models::Gamenight> for Gamenight {
    fn from(value: models::Gamenight) -> Self {
        Self {
            name: value.name,
            start_time: DateTime::parse_from_rfc3339(&value.datetime).unwrap().into()
        }
    }
}
impl Display for Gamenight {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        writeln!(f, r#"
Name: {}
When: {}
"#, self.name, self.start_time.format("%d-%m-%Y %H:%M"))
    }
}